//+------------------------------------------------------------------+
//|                                                         ball.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
#resource "ball.bmp"
//+------------------------------------------------------------------+
input uint FrameDelay=30;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CGame
  {
   uint              m_ticks;
   double            m_angle;
   double            m_speed;
   double            m_x;
   double            m_y;
   double            m_fps_old;
   double            m_fps_old_time;
   double            m_fps_old_count;

public:
                     CGame();
                    ~CGame();
   void              Click(int x,int y);
   void              Tick();
   void              Init();
   void              Deinit();
  };

CGame ExtGame;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
void OnInit() { ExtGame.Init(); }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &)
  {
   switch(id)
     {
      case CHARTEVENT_CLICK:
         ExtGame.Click((int)lparam,(int)dparam);
         break;
      case CHARTEVENT_CUSTOM:
         ExtGame.Tick();
         break;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CGame::Click(int x,int y)
  {
   int    ox=(int)m_x+(int)ObjectGetInteger(0,"ball",OBJPROP_XSIZE)/2;
   int    oy=(int)m_y+(int)ObjectGetInteger(0,"ball",OBJPROP_YSIZE)/2;
   int    ow=ox-x;
   int    oh=oy-y;
//---        
   double dist=sqrt(ow*ow+oh*oh);
//---       
   if(dist>200 || !dist) return;
//---      
   double angl=acos(fabs(ow)/dist)+M_PI;
//---     
   if(oh<0)
     {
      if(ow>0) angl=M_PI-angl;
     }
   else
     {
      if(ow>0) angl=M_PI+angl;
      else     angl=M_PI*2-angl;
     }
//---      (  ))
   dist=20-dist/10;
//---       
   ow  =int(m_speed*cos(m_angle)+dist*cos(angl));
   oh  =int(m_speed*sin(m_angle)+dist*sin(angl));
//---     ()    
   m_speed=sqrt(ow*ow+oh*oh)+0.000001;
   m_angle=M_PI+acos(fabs(ow)/m_speed);
//---    
   if(oh<0)
     {
      if(ow>0) m_angle=M_PI-m_angle;
     }
   else
     {
      if(ow>0) m_angle=M_PI+m_angle;
      else     m_angle=M_PI*2-m_angle;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CGame::Tick()
  {
   //---   25   
   if((GetTickCount()-m_ticks)>=FrameDelay)
     {
      m_ticks=GetTickCount();
      //---  st x  y   
      int maxx=int(ChartGetInteger(0,CHART_WIDTH_IN_PIXELS) -ObjectGetInteger(0,"ball",OBJPROP_XSIZE));
      int maxy=int(ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS)-ObjectGetInteger(0,"ball",OBJPROP_YSIZE));
      //---    
      double _cos=cos(m_angle);
      double _sin=sin(m_angle);
      double nx=m_x+m_speed*_cos;
      double ny=m_y+m_speed*_sin;
      //---  -   (   ))
      if(m_x>maxx && nx>m_x) { m_angle=M_PI-m_angle; m_speed-=0.5; }
      if(m_x<0 && nx<m_x)    { m_angle=M_PI-m_angle; m_speed-=0.5; }
      if(m_y>maxy && ny>m_y) { m_angle=2*M_PI-m_angle; m_speed-=0.5; }
      if(m_y<0 && ny<m_y)    { m_angle=2*M_PI-m_angle; m_speed-=0.5; }
      //----    
      if(m_angle<0) m_angle+=2*M_PI;
      if(m_speed<0) m_speed=0;

      ObjectSetInteger(0,"ball",OBJPROP_XDISTANCE,int(m_x=nx));
      ObjectSetInteger(0,"ball",OBJPROP_YDISTANCE,int(m_y=ny));
      ChartRedraw();
      
      m_fps_old_count++;
     }
//---
   if((GetTickCount()-m_fps_old_time)>1000)
     {
      if(m_fps_old!=m_fps_old_count)
        {
         m_fps_old=m_fps_old_count;
         Comment("fps: "+(string)m_fps_old);
        }
      //---
      m_fps_old_count =0;
      m_fps_old_time  =GetTickCount();
     }
//---
   EventChartCustom(0,0,0,0,NULL);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CGame::CGame(void)
  {
   m_ticks        =GetTickCount();
   m_angle        =M_PI/6;
   m_speed        =3;
   m_x            =200;
   m_y            =200;
   m_fps_old      =0;
   m_fps_old_time =m_ticks;
   m_fps_old_count=0;
//---
   ObjectCreate(0,"ball",OBJ_BITMAP_LABEL,0,0,0);
   ObjectSetString(0,"ball",OBJPROP_BMPFILE,"::ball.bmp");
   ObjectSetInteger(0,"ball",OBJPROP_XDISTANCE,(long)m_x);
   ObjectSetInteger(0,"ball",OBJPROP_YDISTANCE,(long)m_y);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CGame::Init(void)
  {
   EventChartCustom(0,0,0,0,NULL);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CGame::~CGame(void)
  {  
   ObjectDelete(0,"ball");  
  }
//+------------------------------------------------------------------+
